security:
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    role_hierarchy:
        ROLE_ADMIN: [ ROLE_USER ]

    providers:
        users:
            entity:
                class: App\Entity\User
                property: email

    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false

        admin:
            pattern:  ^/admin
            provider: users
            user_checker: App\Security\UserChecker  # <-- Agrega esta línea
            form_login:
                # submit the login form here
                check_path: /admin/login_check
                # the user is redirected here when he/she needs to login
                login_path: /admin/login
                #use_referer: true
            logout:
                path:   /admin/logout
                target: /admin/login
                invalidate_session: true
                delete_cookies:
                    cs_admin: { path: /admin }

        api:
            pattern: ^/api
            stateless: true
            entry_point: jwt
            json_login:
                check_path: /api/login # or, if you have defined a route for your login path, the route name you used
                username_path: email
                password_path: password
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure
            jwt: ~
            refresh_jwt:
                check_path: /api/token/refresh

        main:
            pattern: ^/
            security: false

    access_control:
        - { path: ^/admin/login, roles: PUBLIC_ACCESS }
        - { path: ^/admin, roles: IS_AUTHENTICATED_FULLY }
        - { path: ^/api/docs$, roles: PUBLIC_ACCESS }
        - { path: ^/api/index\.(jsonld|json|jsonopenapi|html)$, roles: PUBLIC_ACCESS }
        - { path: ^/api/login, roles: PUBLIC_ACCESS }
        - { path: ^/api/users, roles: PUBLIC_ACCESS }
        - { path: ^/api/token/refresh, roles: PUBLIC_ACCESS }
        - { path: ^/api/shipping/methods, roles: PUBLIC_ACCESS }
        - { path: ^/api/payment/methods, roles: PUBLIC_ACCESS }
        - { path: ^/api/states, roles: PUBLIC_ACCESS }
        - { path: ^/api/cities, roles: PUBLIC_ACCESS }
        - { path: '^/api/states/{id}/cities', roles: PUBLIC_ACCESS }
        - { path: ^/api, roles: IS_AUTHENTICATED_FULLY }

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
